/**********************************************/
/* mqchat.cpp ... MQ classes demo.            */
/* Chat with another session.                 */
/* Part of SoftWoehr Library for IBM MQSeries */
/* Copyright *C* 1999 Jack J. Woehr           */
/* PO Box 51, Golden, Colorado 80402-0051     */
/* http://www.well.com/user/jax/SoftWoehr     */
/* jwoehr@ibm.net jax@well.com                */
/* ********************************************/
/* This is open source software. Please see   */
/* file license.txt. THERE IS NO WARRANTY.    */
/**********************************************/

class chat {

   public :

      class buffer {

         public :

            buffer(int size = 4096)
               : my_size(size)
               , my_buff(new char[size])
               {*my_buff = '\0';}

            ~buffer() { delete my_buff; }

            buffer(const buffer & cb) {

            const char * get_buffer(void) {
               return my_buff;
               }

         protected :

            void set_buff (int size) {
               delete my_buff;
               my_size = size;
               my_buff = new char [my_size];
               *my_buff = '\0';
               }

         private :

            int my_size;
            char * my_buff;
         };                                                 /* class buffer*/

      class connection {

         public      :

            connection (const string & qm_name
                       , const string& in_q_name
                       , const string& out_q_name
                       )
               : qm(qm_name)
               , in(in_q_name)
               , out(out_q_name)
               {}

            ~connection() {
               if (out.is_opened()) out.close();
               if ( in.is_opened())  in.close();
               if ( qm.is_opened())  qm.close();
               }

            connection & open() {
               try {
               qm.open();
               in.open(qm);
               out.open(qm);

                  }
               catch (MQException & ex) {
                  cerr << "MQException caught: " << endl;
                  cerr << ex.get_text();         << endl;
                  }

               }

            connection & close()  {
               if (out.is_opened()) out.close();
               if ( in.is_opened())  in.close();
               if ( qm.is_opened())  qm.close();
               return *this;
               }

         protected   :

            connection();

         private     :

            MQQueueManager qm;
            MQQueue in;
            MQQueue out;

   };                                                         /* class chat*/

class connection

char inbuff  [4096];
char outbuff [4096];



int main (int argc, char *argv[]) {


      /* Make sure we've been given a queue manager name, queue name and message. */
   if (argc != 3) {
      cout << "usage: " << argv[0] << " queue_manager_name queue_name" << endl;
      result = 10;
      exit (result);
      }

   while(
