/**********************************************/
/* mqqmobj.cpp ... Queue Mgr obj implement.   */
/* Part of SoftWoehr Library for IBM MQSeries */
/* Copyright *C* 1999 Jack J. Woehr           */
/* PO Box 51, Golden, Colorado 80402-0051     */
/* http://www.well.com/user/jax/SoftWoehr     */
/* jwoehr@ibm.net jax@well.com                */
/* ********************************************/
/* This is open source software. Please see   */
/* file license.txt. THERE IS NO WARRANTY.    */
/**********************************************/
#ifndef SW_MQQMOBJ_CPP
#define SW_MQQMOBJ_CPP

#ifndef SW_MQQMOBJ_HPP
   #include "mqqmobj.hpp"
#endif // SW_MQQMOBJ_HPP

using namespace std;
using namespace SoftWoehr;

/** Represents a queue */
//class MQQueueManagerObject : public MQObject
//   public   :

      /** Create an MQQueueManagerObject with the descriptor already set to Queue */
      MQQueueManagerObject::MQQueueManagerObject() {
         my_descriptor.object_type_queue_manager();
         }

      /** Dtor */
      MQQueueManagerObject::~MQQueueManagerObject() {}

/** Open a given queue manager as an object. */
MQQueueManagerObject & MQQueueManagerObject::
   open( MQQueueManager & queue_manager
       , const MQObject::Options & options
       )
   {

   /* Instance extra string fields in pre-created descriptor. */
   my_descriptor.set_object_name("");
   /*  If ObjectType is MQOT_Q_MGR, special rules apply; in this case the name must be entirely blank up */
   /*     to the first null character or the end of the field. */
   /*   -  1.4.4 in MQSeries App Prg Ref */

   my_descriptor.set_object_queue_manager_name(queue_manager.get_name());

   MQObject::open( queue_manager // sets my_queue_manager from passed-in
                 , my_descriptor // already filled out
                 , options       // passed in
                 )
                 ;

   return *this;
   }/* MQQueue & MQQueueManagerObject::open( MQQueueManager & queue_manager*/
     /*               , string         & queue_name */
     /*               , MQObject::Options & options */
     /*               )   */

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/* The code within these blocks was autogenerated    */
/* using the following files found in $JXMQ/pl.      */
/* atrqmihp.pl atrqmicp.pl atrqmchp.pl atrqmccp.pl   */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */

/** Character attribute factory for MQCA_COMMAND_INPUT_Q_NAME */
MQInquiry::character_attribute *
   MQQueueManagerObject::mqca_command_input_q_name(void) {
      return new MQInquiry::character_attribute
         ( MQCA_COMMAND_INPUT_Q_NAME
         , MQ_Q_NAME_LENGTH
         ,"MQCA_COMMAND_INPUT_Q_NAME // System command input queue name"
         )
         ;
         }
/** Character attribute factory for MQCA_DEAD_LETTER_Q_NAME */
MQInquiry::character_attribute *
   MQQueueManagerObject::mqca_dead_letter_q_name(void) {
      return new MQInquiry::character_attribute
         ( MQCA_DEAD_LETTER_Q_NAME
         , MQ_Q_NAME_LENGTH
         ,"MQCA_DEAD_LETTER_Q_NAME // Name of dead-letter queue"
         )
         ;
         }
/** Character attribute factory for MQCA_DEF_XMIT_Q_NAME */
MQInquiry::character_attribute *
   MQQueueManagerObject::mqca_def_xmit_q_name(void) {
      return new MQInquiry::character_attribute
         ( MQCA_DEF_XMIT_Q_NAME
         , MQ_Q_NAME_LENGTH
         ,"MQCA_DEF_XMIT_Q_NAME // Default transmission queue name"
         )
         ;
         }
/** Character attribute factory for MQCA_Q_MGR_DESC */
MQInquiry::character_attribute *
   MQQueueManagerObject::mqca_q_mgr_desc(void) {
      return new MQInquiry::character_attribute
         ( MQCA_Q_MGR_DESC
         , MQ_Q_MGR_DESC_LENGTH
         ,"MQCA_Q_MGR_DESC // Queue manager description"
         )
         ;
         }
/** Character attribute factory for MQCA_Q_MGR_NAME */
MQInquiry::character_attribute *
   MQQueueManagerObject::mqca_q_mgr_name(void) {
      return new MQInquiry::character_attribute
         ( MQCA_Q_MGR_NAME
         , MQ_Q_MGR_NAME_LENGTH
         ,"MQCA_Q_MGR_NAME // Name of local queue manager"
         )
         ;
         }

/** Integer attribute factory for MQIA_CODED_CHAR_SET_ID */
MQInquiry::integer_attribute *
   MQQueueManagerObject::mqia_coded_char_set_id(void) {
      return new MQInquiry::integer_attribute
         ( MQIA_CODED_CHAR_SET_ID
         ,"MQIA_CODED_CHAR_SET_ID // Coded character set identifier."
         )
         ;
         }
/** Integer attribute factory for MQIA_COMMAND_LEVEL */
MQInquiry::integer_attribute *
   MQQueueManagerObject::mqia_command_level(void) {
      return new MQInquiry::integer_attribute
         ( MQIA_COMMAND_LEVEL
         ,"MQIA_COMMAND_LEVEL // Command level supported by queue manager."
         )
         ;
         }
/** Integer attribute factory for MQIA_MAX_HANDLES */
MQInquiry::integer_attribute *
   MQQueueManagerObject::mqia_max_handles(void) {
      return new MQInquiry::integer_attribute
         ( MQIA_MAX_HANDLES
         ,"MQIA_MAX_HANDLES // Maximum number of handles."
         )
         ;
         }
/** Integer attribute factory for MQIA_MAX_MSG_LENGTH */
MQInquiry::integer_attribute *
   MQQueueManagerObject::mqia_max_msg_length(void) {
      return new MQInquiry::integer_attribute
         ( MQIA_MAX_MSG_LENGTH
         ,"MQIA_MAX_MSG_LENGTH // Maximum message length."
         )
         ;
         }
/** Integer attribute factory for MQIA_MAX_PRIORITY */
MQInquiry::integer_attribute *
   MQQueueManagerObject::mqia_max_priority(void) {
      return new MQInquiry::integer_attribute
         ( MQIA_MAX_PRIORITY
         ,"MQIA_MAX_PRIORITY // Maximum priority."
         )
         ;
         }
/** Integer attribute factory for MQIA_MAX_UNCOMMITTED_MSGS */
MQInquiry::integer_attribute *
   MQQueueManagerObject::mqia_max_uncommitted_msgs(void) {
      return new MQInquiry::integer_attribute
         ( MQIA_MAX_UNCOMMITTED_MSGS
         ,"MQIA_MAX_UNCOMMITTED_MSGS // Maximum number of uncommitted messages within a unit of work."
         )
         ;
         }
/** Integer attribute factory for MQIA_PLATFORM */
MQInquiry::integer_attribute *
   MQQueueManagerObject::mqia_platform(void) {
      return new MQInquiry::integer_attribute
         ( MQIA_PLATFORM
         ,"MQIA_PLATFORM // Platform on which the queue manager resides."
         )
         ;
         }
/** Integer attribute factory for MQIA_SYNCPOINT */
MQInquiry::integer_attribute *
   MQQueueManagerObject::mqia_syncpoint(void) {
      return new MQInquiry::integer_attribute
         ( MQIA_SYNCPOINT
         ,"MQIA_SYNCPOINT // Syncpoint availability."
         )
         ;
         }
/** Integer attribute factory for MQIA_TRIGGER_INTERVAL */
MQInquiry::integer_attribute *
   MQQueueManagerObject::mqia_trigger_interval(void) {
      return new MQInquiry::integer_attribute
         ( MQIA_TRIGGER_INTERVAL
         ,"MQIA_TRIGGER_INTERVAL // Trigger interval."
         )
         ;
         }
/** Integer attribute factory for MQIA_AUTHORITY_EVENT */
MQInquiry::integer_attribute *
   MQQueueManagerObject::mqia_authority_event(void) {
      return new MQInquiry::integer_attribute
         ( MQIA_AUTHORITY_EVENT
         ,"MQIA_AUTHORITY_EVENT // Control attribute for authority events."
         )
         ;
         }
/** Integer attribute factory for MQIA_INHIBIT_EVENT */
MQInquiry::integer_attribute *
   MQQueueManagerObject::mqia_inhibit_event(void) {
      return new MQInquiry::integer_attribute
         ( MQIA_INHIBIT_EVENT
         ,"MQIA_INHIBIT_EVENT // Control attribute for inhibit events."
         )
         ;
         }
/** Integer attribute factory for MQIA_LOCAL_EVENT */
MQInquiry::integer_attribute *
   MQQueueManagerObject::mqia_local_event(void) {
      return new MQInquiry::integer_attribute
         ( MQIA_LOCAL_EVENT
         ,"MQIA_LOCAL_EVENT // Control attribute for local events."
         )
         ;
         }
/** Integer attribute factory for MQIA_REMOTE_EVENT */
MQInquiry::integer_attribute *
   MQQueueManagerObject::mqia_remote_event(void) {
      return new MQInquiry::integer_attribute
         ( MQIA_REMOTE_EVENT
         ,"MQIA_REMOTE_EVENT // Control attribute for remote events."
         )
         ;
         }
/** Integer attribute factory for MQIA_START_STOP_EVENT */
MQInquiry::integer_attribute *
   MQQueueManagerObject::mqia_start_stop_event(void) {
      return new MQInquiry::integer_attribute
         ( MQIA_START_STOP_EVENT
         ,"MQIA_START_STOP_EVENT // Control attribute for start stop events."
         )
         ;
         }
/** Integer attribute factory for MQIA_PERFORMANCE_EVENT */
MQInquiry::integer_attribute *
   MQQueueManagerObject::mqia_performance_event(void) {
      return new MQInquiry::integer_attribute
         ( MQIA_PERFORMANCE_EVENT
         ,"MQIA_PERFORMANCE_EVENT // Control attribute for performance events."
         )
         ;
         }

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/* End of autogenerated code.                        */
/* using the following files found in $JXMQ/pl.      */
/* atrqmihp.pl atrqmicp.pl atrqmchp.pl atrqmccp.pl   */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */

/** Compose an inquiry which applies to any queue mgr.
  * Ask everything you can MQINQ about a queue.
  */
MQInquiry * MQQueueManagerObject::inquiry_any_queue_manager() {
   MQInquiry *pmqi = new MQInquiry;
   pmqi->add (mqia_performance_event());
   pmqi->add (mqia_remote_event());
   pmqi->add (mqia_inhibit_event());
   pmqi->add (mqia_authority_event());
   pmqi->add (mqia_start_stop_event());
   pmqi->add (mqia_trigger_interval());
   pmqi->add (mqia_syncpoint());
   pmqi->add (mqia_max_uncommitted_msgs());
   pmqi->add (mqia_max_priority());
   pmqi->add (mqia_max_msg_length());
   pmqi->add (mqia_max_handles());
   pmqi->add (mqia_command_level());
   pmqi->add (mqia_coded_char_set_id());
   pmqi->add (mqca_q_mgr_name());
   pmqi->add (mqca_q_mgr_desc());
   pmqi->add (mqca_dead_letter_q_name());
   pmqi->add (mqca_command_input_q_name());
   return pmqi;
   }

#endif                                 /* SW_MQQMOBJ_CPP            */
